<?php
/***************************************************************************
 *	admin_EasyBAN.php
 *
 *	begin		: September 2006
 *	version		: 9 December 2006
 *	copyright	: (C) 2006,2007 grandolini.net
 *	email		: maraja@users.sourceforge.net
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);
$phpbb_root_path = '../';

///
///
define('EASYBAN_VER', '0.1.2');
define('EASYBAN_VER_CHKFILE', 'eb01x');
///
///

if ( (!empty($setmodules)) && (stripslashes($HTTP_GET_VARS['page']) != 'full') )
{
	//
	//	entries to be displayed in the ACP index
	//
	if ( @file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx) )
	{
		include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx);
	}
	else
	{
		include($phpbb_root_path . 'language/lang_english/lang_EasyBAN.' . $phpEx);
	}

	$file = basename(__FILE__);
	$module['EasyBAN']['EasyBAN_admin'] = "$file?mode=admin";
	$module['EasyBAN']['EasyBAN_settings'] = "$file?mode=settings";
	$module['EasyBAN']['EasyBAN_help'] = "$file?mode=help";
	return;
}

$action = '';
$action = ( !empty($HTTP_POST_VARS['action']) ) ? stripslashes(trim($HTTP_POST_VARS['action'])) : '';

if( ($action == 'b2admin') || ($action == 'b2forum') || ($action == 'b2topic') || ($action == 'b2post') )
{
	$no_page_header = true;
}
unset($action);

//
//	Load phpBB code, do session and security stuff
//
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

//
$script_path = 'admin/';
//

//	Load the EasyBAN language file
if ( @file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx) )
{
	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx);
}
else
{
	include($phpbb_root_path . 'language/lang_english/lang_EasyBAN.' . $phpEx);
}

$action = '';
$action = ( !empty($HTTP_POST_VARS['action']) ) ? stripslashes(trim($HTTP_POST_VARS['action'])) : '';

$mode = '';
$mode = ( !empty($HTTP_GET_VARS['mode']) ) ? stripslashes($HTTP_GET_VARS['mode']) : stripslashes(trim($HTTP_POST_VARS['mode']));

switch($action)
{
	case 'admin':
	case 'detail':
		$mode = $action;
		break;
}

$submit = ( !empty($HTTP_POST_VARS['submit']) ) ? stripslashes(trim($HTTP_POST_VARS['submit'])) : '';

$filter_option = ( !empty($HTTP_POST_VARS['filter_option']) ) ? stripslashes(trim($HTTP_POST_VARS['filter_option'])) : '';
$filter_option_row = ( !empty($HTTP_POST_VARS['filter_option_row']) ) ? stripslashes(trim($HTTP_POST_VARS['filter_option_row'])) : '';

$forum_id = ( !empty($HTTP_POST_VARS['forum_id']) ) ? intval($HTTP_POST_VARS['forum_id']) : 0;
$post_id = ( !empty($HTTP_POST_VARS['post_id']) ) ? intval($HTTP_POST_VARS['post_id']) : intval($HTTP_GET_VARS['pid']);
$topic_id = ( !empty($HTTP_POST_VARS['topic_id']) ) ? intval($HTTP_POST_VARS['topic_id']) : intval($HTTP_GET_VARS['tid']);

$c_fullScreen = intval($HTTP_POST_VARS['c_fullScreen']);
//	$c_hide = intval($HTTP_POST_VARS['c_hide']);
$r_hide = intval($HTTP_POST_VARS['r_hide']);
$c_alltopic = intval($HTTP_POST_VARS['c_alltopic']);
$chk_alltopic_type = 'checkbox';
$c_ban_user = intval($HTTP_POST_VARS['c_ban_user']);
$c_ban_email = intval($HTTP_POST_VARS['c_ban_email']);
$c_ban_ip = intval($HTTP_POST_VARS['c_ban_ip']);

$poster_id = intval($HTTP_POST_VARS['poster_id']);
$poster_email = stripslashes(trim($HTTP_POST_VARS['poster_email']));
$poster_ip_db = stripslashes(trim($HTTP_POST_VARS['poster_ip_db']));

//==============
//
//	back to...
//
//==============
switch($action)
{
	case 'b2admin':
		//
		//	admin
		//
		$page2open = $board_config['server_name'] . $board_config['script_path'] . append_sid('admin/admin_EasyBAN.' . $phpEx) . '&mode=admin';
		header("Location: http://$page2open");
		die;
		break;

	case 'b2forum':
		//
		//	forum
		//
		if( $forum_id == 0 )
		{
			$page2open = $board_config['server_name'] . $board_config['script_path'] . append_sid('index.' . $phpEx);
		}
		else
		{
			$page2open = $board_config['server_name'] . $board_config['script_path'] . append_sid('viewforum.' . $phpEx . "?f=$forum_id");
		}
	
		if( ($c_fullScreen == 1) || ($forum_id == 0) )
		{
			?><script>top.parent.location.href='http://<?=$page2open?>';</script><?php
		}
		else
		{
			header("Location: http://$page2open");
		}
		die;
		break;

	case 'b2topic':
		//
		//	topic
		//
		if( $topic_id > 0 )
		{
			$page2open = $board_config['server_name'] . $board_config['script_path'] . append_sid('viewtopic.' . $phpEx . "?t=$topic_id");
		
			if( $c_fullScreen == 1 )
			{
				?><script>top.parent.location.href='http://<?=$page2open?>';</script><?php
			}
			else
			{
				header("Location: http://$page2open");
			}
			die;
		}
		break;

	case 'b2post':
		//
		//	post
		//
		if( ($topic_id > 0) && ($post_id > 0) )
		{
			$page2open = $board_config['server_name'] . $board_config['script_path'] . append_sid('viewtopic.' . $phpEx . "?t=$topic_id#$post_id");
		
			if( $c_fullScreen == 1 )
			{
				?><script>top.parent.location.href='http://<?=$page2open?>';</script><?php
			}
			else
			{
				header("Location: http://$page2open");
			}
			die;
		}
		break;
}

////////
////////
////////	make sure EasyBAN_functions is where it needs to be or else the user will get a blank screen :roll:
////////
////////

if (!file_exists($phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_functions.' . $phpEx))
{
	$message = sprintf($lang['EasyBAN_err_no_file'], $phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_functions.' . $phpEx);
	if( !defined('IN_ADMIN') )
	{
		// We can reach this point if pagestart has not been called, therefore we better close the DB and do a plain PHP die.
		$db->sql_close();
		die($message);
	}
	message_die(GENERAL_ERROR, $message);
}

include($phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_functions.' . $phpEx);
include($phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_links.' . $phpEx);

if( $submit == $lang['Go'] )
{
	$settings = get_settings(1);
	$update_info = array();
	$u = 0;

	unset($group);
	if( is_array($HTTP_POST_VARS['c_posts']) )
	{
		$i = 0;

		foreach( $HTTP_POST_VARS['c_posts'] as $post_id )
		{
			$group[$i] = intval($post_id);
			$i++;
		}
	}

	if( is_array($group) )
	{
		//================================
		//
		//	hide/unhide a group of posts
		//
		//================================
		//
		//	set switches
		//
		$c_alltopic = 0;  // hide/unhide ONLY the selected post
		//
		//	9 => do NOT change the banning status of:
		//
		$c_ban_user = 9;  // user
		$c_ban_email = 9; // email
		$c_ban_ip = 9;    // ip

		switch( $action )
		{
			case 'ghide':
				if($settings['EasyBAN_grpban_user_radio'] == 1)  { $c_ban_user = 1; }
				if($settings['EasyBAN_grpban_email_radio'] == 1) { $c_ban_email = 1; }
				if($settings['EasyBAN_grpban_ip_radio'] == 1)    { $c_ban_ip = 1; }
				$r_hide = 1;
				break;

			case 'gunhide':
				if($settings['EasyBAN_grpban_user_radio'] == 1)  { $c_ban_user = 0; }
				if($settings['EasyBAN_grpban_email_radio'] == 1) { $c_ban_email = 0; }
				if($settings['EasyBAN_grpban_ip_radio'] == 1)    { $c_ban_ip = 0; }
				$r_hide = 0;
				break;
		}

		//
		//	loop within the selected posts to do the required job
		//
		foreach( $group as $post_id )
		{
			//	get post info
			//
			$row = get_post_data($post_id);
			$poster_id = $row['poster_id'];
			$poster_email = $row['user_email'];
			$poster_ip = $row['poster_ip'];
			$poster_ip_db = $row['poster_ip'];
			$forum_id = $row['forum_id'];
			$topic_id = $row['topic_id'];

			//	if the post is already hided by its topic, do nothing
			//
			$sql = 'SELECT * FROM ' . HIDED_TABLE . " 
					WHERE
					hide_id = $topic_id AND
					hide_type = 1 ";
			if( $result = $db->sql_query($sql) )
			{
				if( $db->sql_affectedrows() == 0 )
				{
					//	do the job
					//
					$update_info = _hide($r_hide, $c_alltopic, $topic_id, $post_id, $poster_id, $poster_email, $poster_ip, $update_info);
					$update_info = _ban($c_ban_user, $c_ban_email, $c_ban_ip, $post_id, $poster_id, $poster_email, $poster_ip, $update_info);
				}
			}
		}

		//	show the return option list for the group post
		$template->assign_block_vars('group', array());

		$post_id = 0;
		$forum_id = 0;
		$topic_id = 0;
	}
	elseif( ($post_id > 0) && ($action == 'update') )
	{
		//========================
		//
		//	update a single post
		//
		//========================
		//
		//	get post info
		//
		$row = get_post_data($post_id);
		$poster_id = $row['poster_id'];
		$poster_email = $row['user_email'];
		$poster_ip = $row['poster_ip'];
		$poster_ip_db = $row['poster_ip'];
		$forum_id = $row['forum_id'];
		$topic_id = $row['topic_id'];

		$update_info = _hide($r_hide, $c_alltopic, $topic_id, $post_id, $poster_id, $poster_email, $poster_ip, $update_info);
		$update_info = _ban($c_ban_user, $c_ban_email, $c_ban_ip, $post_id, $poster_id, $poster_email, $poster_ip, $update_info);

		//	show the return option list for the single post
		$template->assign_block_vars('single', array());
	}

	//	show results
	//
	$template->set_filenames(array(
		'EasyBAN_header' => 'admin/EasyBAN_header.tpl')
	);

	$template->assign_vars(array(
		'L_TITLE' => $lang['EasyBAN_title'],
		'L_FORUM_LINK' => '<a href="http://' . $easyban_links['FORUM'] . '" target="_top">' . $lang['EasyBAN_forum_link'] . '</a>',
		'L_SUPPORT_LINK' => '<a href="http://' . $easyban_links['SUPPO'] . '">' . $lang['EasyBAN_support_link'] . '</a>',
		'L_EASYBAN_VER' => EASYBAN_VER)
	);

	$template->pparse('EasyBAN_header');

	$template->set_filenames(array(
		'body' => 'admin/EasyBAN_update_results.tpl')
	);

	$template->assign_vars(array(
		'L_UPDATE_RESULTS' => $lang['EasyBAN_results'],
		'L_INFO' => $lang['EasyBAN_info'],
		)
	);

	$u = count($update_info);

	if ( $u == 0 )
	{
		$template->assign_block_vars('no_row', array(
			'L_NONE_UPDATED' => $lang['EasyBAN_none_updated'],
			)
		);
	}
	else
	{
		for($i = 0; $i < $u; $i++)
		{
			$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
			$template->assign_block_vars('row', array(
				'ROW_CLASS' => $row_class,
				'INFO' => $update_info[$i],
				)
			);
		}
	}

	$template->assign_vars(array(
		'L_BACK_TO_ADMIN' => $lang['EasyBAN_BTN_b2admin'],
		'L_BACK_TO_FORUM' => $lang['EasyBAN_BTN_b2forum'],
		'L_BACK_TO_TOPIC' => $lang['EasyBAN_BTN_b2topic'],
		'L_BACK_TO_POST' => $lang['EasyBAN_BTN_b2post'],
		'L_GO' => $lang['Go'],

		'S_HIDDEN_FIELDS' =>  '<input type="hidden" name="mode" value="detail" />'
							. '<input type="hidden" name="forum_id" value="' . $forum_id . '" />'
							. '<input type="hidden" name="topic_id" value="' . $topic_id . '" />'
							. '<input type="hidden" name="post_id" value="' . $post_id . '" />',
		'S_ACTION' => append_sid('admin_EasyBAN.' . $phpEx))
	);

	unset($mode);
}

if (isset($mode))
{
	//
	//	help
	//
	if ($mode == 'help')
	{
		$template->set_filenames(array(
			'body' => 'admin/EasyBAN_help.tpl')
		);
		$template->assign_vars(array(
			'L_TITLE' => $lang['EasyBAN_help'])
		);
		$first_item = true;
		foreach( $lang['help'] as $name => $paragraphs )
		{
			if( $first_item )
			{
				$first_item = false;
			}
			else
			{
				$template->assign_block_vars('helpitem.separator', array());
			}
			$template->assign_block_vars('helpitem', array(
				'TITLE' => $paragraphs[0],
				'NAME' => $name
			));
			for( $i = 1; $i < count($paragraphs); $i++ )
			{
				$template->assign_block_vars('helpitem.paragraph', array(
					'TEXT' => $paragraphs[$i]
				));
			}
		}
		$template->pparse('body');
		include('page_footer_admin.'.$phpEx);
	}

	//
	//	header
	//
	$template->set_filenames(array(
		'EasyBAN_header' => 'admin/EasyBAN_header.tpl')
	);

	$template->assign_vars(array(
		'L_TITLE' => $lang['EasyBAN_title'],
		'L_FORUM_LINK' => '<a href="http://' . $easyban_links['FORUM'] . '" target="_top">' . $lang['EasyBAN_forum_link'] . '</a>',
		'L_SUPPORT_LINK' => '<a href="http://' . $easyban_links['SUPPO'] . '">' . $lang['EasyBAN_support_link'] . '</a>',
		'L_EASYBAN_VER' => EASYBAN_VER)
	);

	$template->pparse('EasyBAN_header');

	if( ($mode == 'detail') || ( ($mode == 'detail')  && ($submit != $lang['Go']) ) || ( ($mode == 'admin') && ($submit == $lang['EasyBAN_BTN_details']) ) )
	{
		//=====================
		//
		//	show post details
		//
		//=====================
		//
		if( $topic_id > 0 )
		{

			//	get the first post of the topic
			//
			$sql = 'SELECT * 
					FROM ' . TOPICS_TABLE . ' 
					WHERE topic_id = ' . $topic_id;
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_topic'] . $topic_id, '', __LINE__, __FILE__, $sql);
			}
			$tmp = $db->sql_fetchrow($result);
			$post_id = $tmp['topic_first_post_id'];

			if( strval($post_id) == 0 )
			{
				message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_topic'] . $topic_id, '', __LINE__, __FILE__);
			}
		}

		//
		//	get post data
		//
		$row = get_post_data($post_id);
		$poster_id = $row['poster_id'];
		$user_email = $row['user_email'];
		$poster_ip = $row['poster_ip'];
		$poster_ip_db = $row['poster_ip'];
		$forum_id = $row['forum_id'];
		$topic_id = $row['topic_id'];

		//
		//	get post hide data
		//
		$sql = 'SELECT * FROM ' . HIDED_TABLE . " 
				WHERE 
				hide_id = $post_id AND 
				hide_type = 0 ";
		if( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'] . $post_id, '', __LINE__, __FILE__, $sql);
		}

		if( $db->sql_affectedrows() == 0 )
		{
			//	if the post is not hided try to get the topic hide data
			//
			$sql = 'SELECT * FROM ' . HIDED_TABLE . " 
					WHERE 
					hide_id = $topic_id AND 
					hide_type = 1 ";
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'] . $topic_id, '', __LINE__, __FILE__, $sql);
			}
		}
		$hide_row = $db->sql_fetchrow($result);

		//
		//	get ban info
		//
		$ban_info_userid = '';
		if( $poster_id )
		{
			$sql = 'SELECT * FROM ' . BANLIST_TABLE . " 
					WHERE 
					ban_userid = $poster_id ";
			if( $result = $db->sql_query($sql) )
			{
				$ban_info = $db->sql_fetchrow($result);
			}
			$ban_info_userid = $ban_info['ban_userid'];
		}

		$ban_info_email = '';
		if( $user_email != '' )
		{
			$sql = 'SELECT * FROM ' . BANLIST_TABLE . " 
					WHERE 
					ban_email = '$user_email' ";
			if( $result = $db->sql_query($sql) )
			{
				$ban_info = $db->sql_fetchrow($result);
			}
			$ban_info_email = $ban_info['ban_email'];
		}

		$ban_info_ip = '';
		if( $poster_ip != '' )
		{
			$sql = 'SELECT * FROM ' . BANLIST_TABLE . " 
					WHERE 
					ban_ip = '$poster_ip' ";
			if( $result = $db->sql_query($sql) )
			{
				$ban_info = $db->sql_fetchrow($result);
			}
			$ban_info_ip = $ban_info['ban_ip'];
		}

		if( $submit != $lang['Go'] )
		{
			$c_ban_user = '';
			$c_ban_email = '';
			$c_ban_ip = '';

			if( $ban_info_userid != '') { $c_ban_user = ' checked="checked"'; }
			if( $ban_info_email != '')  { $c_ban_email = ' checked="checked"'; }
			if( $ban_info_ip != '')     { $c_ban_ip = ' checked="checked"'; }

			//
			//	set command line switches
			//
			$r_hide = '';
			if( ( ($hide_row['hide_id'] == $post_id) && ($hide_row['hide_quar'] == 0) ) && ($hide_row['hide_type'] == 0) )
			{
				//	post hided
				//
				$r_hide1 = ' checked="checked"';
				$r_hide = 1;
				$hide_desc = $lang['EasyBAN_mngr_post_hided'];
			}
			else if( ( ($hide_row['hide_id'] == $post_id) && ($hide_row['hide_quar'] == 1) ) && ($hide_row['hide_type'] == 0) )
			{
				//	post quarantined
				//
				$r_hide1 = ' checked="checked"';
				$r_hide = 1;
				$hide_desc = $lang['EasyBAN_mngr_post_quarantined'];
			}
			else if ( ($hide_row['hide_type'] == 1) )
			{
				//	post hided within its topic
				//
				$r_hide0 = ' checked="checked"';
				$r_hide = 0;
				$hide_desc = $lang['EasyBAN_mngr_post_thided'];
				$chk_alltopic = ' checked="checked"';
				$chk_alltopic_type = 'radio';
			}
			else
			{
				$r_hide0 = ' checked="checked"';
				$r_hide = 0;
				$hide_desc = $lang['EasyBAN_mngr_post_unhided'];
			}
		}

		//
		//	format message contents
		//
		$message = $row['post_text']; //--| next version |--// $message = format_message($row['post_text'], $row['bbcode_uid'], $row['enable_html']);

		//
		//	format author info
		//
		$author = '';
		if( $row['username'] != '' )
		{
			$author .= $row['username'] . ' ';
		}
		if( $row['post_username'] != '' )
		{
			$author .= '(' . $row['post_username'] . ') ';
		}
		if( $author )
		{
			$author = '<input type="checkbox" name="c_ban_user" value="1"' . $c_ban_user . ' />&nbsp;<b>' . $author . '</b> ';
		}
 		if( $row['user_email'] != '' ) 
		{
			$author .=  '<input ' . $hide . ' type="checkbox" name="c_ban_email" value="1"' . $c_ban_email . ' />&nbsp;<b>' . $row['user_email'] . '</b> ';
		}
		$author .= '<input type="checkbox" name="c_ban_ip" value="1"' . $c_ban_ip . ' />&nbsp;<b>' . decode_ip($poster_ip_db) . '</b>';

		//
		//	load the template
		//
		$template->set_filenames(array(
			"body" => "admin/EasyBAN_details.tpl")
		);

		if( $c_fullScreen == 1 )
		{
			$chk_fullScreen = ' checked="checked"'; // not fully implemented yet, next version
		}

		if( $c_alltopic == 1 )
		{
			$chk_alltopic = ' checked="checked"';
		}

		$template->assign_vars(array(
			'AUTHOR_ID' => $row['poster_id'],
			'AUTHOR' => $author,
			'FORUM_ID' => $forum_id,
			'FORUM' => $row['forum_name'],
			'TOPIC_ID' => $topic_id,
			'TOPIC' => $row['topic_title'],
			'POST_ID' => $post_id,
			'POST' => $row['post_subject'],
			'MESSAGE' => $message,
			'DATE' => create_date($board_config['default_dateformat'], $row['post_time'], $board_config['board_timezone']),
			)
		);

		$template->assign_vars(array(
			'L_DETAIL' => $lang['EasyBAN_mngr'],
			'L_DETAIL_DESC' => $lang['EasyBAN_mngr_desc'],

			'L_POST_DATA' => $lang['EasyBAN_mngr_data'] . ' [' . $hide_desc . ']',
			'L_AUTHOR' => $lang['EasyBAN_AUTHOR'],
			'L_FORUM' => $lang['EasyBAN_FORUM'],
			'L_TOPIC' => $lang['EasyBAN_TOPIC'],
			'L_POST' => $lang['EasyBAN_POST'],
			'L_MESSAGE' => $lang['EasyBAN_MESSAGE'],
			'L_DATE' => $lang['EasyBAN_DATE'],

			'L_BACK_TO_ADMIN' => $lang['EasyBAN_BTN_b2admin'],
			'L_BACK_TO_FORUM' => $lang['EasyBAN_BTN_b2forum'],
			'L_BACK_TO_TOPIC' => $lang['EasyBAN_BTN_b2topic'],
			'L_BACK_TO_POST' => $lang['EasyBAN_BTN_b2post'],
			'L_UPDATE' => $lang['EasyBAN_BTN_update'],
			'L_GO' => $lang['Go'],

			'S_COMMAND_LINE' =>  '<input type="hidden" name="mode" value="detail" />'
							//	. '<input type="checkbox" name="c_hide" value="1" ' . $c_hide . ' />' . $lang['EasyBAN_C_hide']
								. ' ' . $lang['EasyBAN_R_hide'] . ':'
								. '<input type="radio" name="r_hide" value="1"' . $r_hide1 . ' />' . $lang['EasyBAN_R_hide1']
								. '<input type="radio" name="r_hide" value="0"' . $r_hide0 . ' />' . $lang['EasyBAN_R_hide0'] . ' '
								. '<input type="' . $chk_alltopic_type . '" name="c_alltopic" value="1"' . $chk_alltopic . ' />' . $lang['EasyBAN_C_alltopic'] . ' '
							//	. '<input type="checkbox" name="c_fullScreen" value="1"' . $chk_fullScreen . ' />' . $lang['EasyBAN_C_fullScreen']
								. '<input type="hidden" name="forum_id" value="' . $forum_id . '" />'
								. '<input type="hidden" name="topic_id" value="' . $topic_id . '" />'
								. '<input type="hidden" name="post_id" value="' . $post_id . '" />'
								. '<input type="hidden" name="poster_id" value="' . $poster_id . '" />'
								. '<input type="hidden" name="poster_email" value="' . $poster_email . '" />'
								. '<input type="hidden" name="poster_ip_db" value="' . $poster_ip_db . '" />'
								. '<input type="hidden" name="filter_option" value="' . htmlspecialchars($filter_option_row) . '" />',
			'S_ACTION' => append_sid('admin_EasyBAN.' . $phpEx))
		);

		//
		//	avoid further processing
		//
		$mode = '';
	}

	if($mode == 'admin')
	{
		//===============
		//
		//	admin posts
		//
		//===============
		//
	
		//	load the template
		$template->set_filenames(array(
			"body" => "admin/EasyBAN_admin.tpl")
		);

		//
		//	set data filtering
		//
		$filter_select_options = '';
		for( $i = 0; $i < 4; $i++ )
		{
			$selected = $i == $filter_option ? ' selected="selected"' : '';
			$filter_select_options .= '<option value="' . $i . '"' . $selected . '>' . htmlspecialchars($lang['EasyBAN_opt_filters'][$i]) . '</option>';
		}

		//
		//	get post(s) data
		//
		$sql = 'SELECT DISTINCT 
						h.*, 
						f.forum_name, 
						p.post_id, p.post_time, p.topic_id, p.forum_id, p.poster_id, 
						i.post_subject, i.post_text,  i.bbcode_uid, 
						t.topic_title, t.topic_id 
				FROM ' 
					. HIDED_TABLE . ' h, '
					. FORUMS_TABLE . ' f, '
					. POSTS_TABLE . ' p, '
					. POSTS_TEXT_TABLE . ' i, '
					. TOPICS_TABLE . ' t
				WHERE ';

		switch( $filter_option )
		{
			case 1:
				//
				//	only quarantined posts
				//
				$sql .= 'h.hide_id = p.post_id AND 
						 h.hide_quar = 1 AND 
						 h.hide_type = 0 AND 
						 i.post_id = h.hide_id AND 
						 f.forum_id = p.forum_id AND 
						 t.topic_id = p.topic_id ';
				$filter_status = $lang['EasyBAN_Filtered'];
				break;

			case 2:
				//
				//	only banned posts
				//
				$sql .= 'h.hide_id = p.post_id AND 
						 h.hide_quar = 0 AND 
						 h.hide_type = 0 AND
						 i.post_id = h.hide_id AND 
						 f.forum_id = p.forum_id AND 
						 t.topic_id = p.topic_id ';
				$filter_status = $lang['EasyBAN_Filtered'];
				break;

			case 3:
				//
				//	only posts within hided topics
				//
				$sql .= 'h.hide_id = t.topic_id AND 
						 h.hide_type = 1 AND 
						 p.topic_id = t.topic_id AND
						 f.forum_id = p.forum_id AND 
						 p.topic_id = t.topic_id AND
						 i.post_id = p.post_id ';
				$filter_status = $lang['EasyBAN_Filtered'];
				break;

			default:
				//
				//	all posts
				//
				$sql .= '( 
							h.hide_id = p.post_id AND 
							h.hide_type = 0 AND 
							f.forum_id = p.forum_id AND 
							p.topic_id = t.topic_id AND
							i.post_id = p.post_id 
						 )
						 OR
						 ( 
							h.hide_id = p.topic_id AND 
							h.hide_type = 1 AND 
							f.forum_id = p.forum_id AND 
							p.topic_id = t.topic_id AND 
							i.post_id = p.post_id 
						 ) ';
				$filter_status = $lang['EasyBAN_Unfiltered'];
		}
		$sql .= 'ORDER BY 
					p.post_id DESC'; // f.forum_id ASC, p.topic_id DESC
		if( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_hided'], '', __LINE__, __FILE__, $sql);
		}

		$total_hided = 0;
		while( $row = $db->sql_fetchrow($result) )
		{
			$row_class = ( !($total_hided % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
			if( $row['hide_type'] == 1 )
			{
				//	assign a different color to the "hided by topic" rows
				//
				$row_class = 'row3';
				$check_item = ''; // no group operations available
			}
			else
			{
				$check_item = '<input type="checkbox" style="margin:0 0 6px 0;padding:0px;" name="c_posts[' . $total_hided . ']" value="' . $row['post_id'] . '"' . $check . ' />';
			}

			$icon_quar = '';
			if( $row['hide_quar'] == 1 )
			{
				//	set the variable to show the "quarantined" icon
				//
				$icon_quar = '<br /><img src="../' . $images['icon_quar'] . '" width="19" height="18" alt="' . $lang['EasyBAN_BTN_quarantined'] . '" title="' . $lang['EasyBAN_BTN_quarantined'] . '" />';
			}

			//
			//	format message contents
			//
			$message = $row['post_text']; /// $message = format_message($row['post_text'], $row['bbcode_uid'], $row['enable_html']); // next version

			/*
				---------------------------------------------------------------------
				keeping this for future needs -- see also the RADIO assign here below
				---------------------------------------------------------------------
				$radio_var = ( !empty($HTTP_POST_VARS['r_posts']) ) ? stripslashes(trim($HTTP_POST_VARS['r_posts'])) : '';
				$radio='';
				if( ($total_hided == 0 && $radio_var == '') || ($radio_var == $row['post_id']) )
				{
					#	if is the first row and no radio was selected OR we are on the selected line
					#	check the radio button
					#
					$radio = ' checked'; $HTTP_POST_VARS['r_posts'] = $row['post_id'];
				}
			*/

			$check='';
			if( $HTTP_POST_VARS['c_posts'][$total_hided] == $row['post_id'] )
			{
				$check = ' checked';
			}

			$template->assign_block_vars('hided', array(
				'ROW_CLASS' => $row_class,
			/*	'RADIO' => '<input type="radio" name="r_posts" value="' . $row['post_id'] . '"' . $radio . ' />', */
				'CHECK' => $check_item . $icon_quar,
				'POST_DATE' => create_date($board_config['default_dateformat'], $row['post_time'], $board_config['board_timezone']),
				'FORUM' => '[' . $row['forum_id'] . ']&nbsp;' . $row['forum_name'],
				'TOPIC' => '[' . $row['topic_id'] . ']&nbsp;' . $row['topic_title'],
				'SUBJE' => '[' . $row['post_id'] . ']&nbsp;' . $row['post_subject'],
				'POST' => $message,
	
				'S_HIDDEN_FIELDS' =>  '<input type="hidden" name="mode" value="admin" />'
									. '<input type="hidden" name="post_id" value="' . $row['post_id'] . '" />',

				'S_ACTION' => append_sid('admin_EasyBAN.' . $phpEx),
				)
			);

			$total_hided++;
		}

		if ( $total_hided == 0 )
		{
			$template->assign_block_vars('no_hided', array());
			$template->assign_vars(array('L_NONE_HIDED' => $lang['EasyBAN_none_found']));
		}

		$template->assign_vars(array(
			'L_HIDED' => $lang['EasyBAN_hided'],
			'L_HIDED_DESC' => $lang['EasyBAN_hided_desc'],

			'L_TOTAL_MODS' => $lang['EasyBAN_tot_hided'],
			'S_TOTAL_MODS' => $total_hided,

			'L_POST_DATE' => $lang['EasyBAN_DATE'],
			'L_FORUM' => $lang['EasyBAN_FORUM'],
			'L_TOPIC' => $lang['EasyBAN_TOPIC'],
			'L_SUBJE' => $lang['EasyBAN_POST'],
			'L_POST' => $lang['EasyBAN_MESSAGE'],

			'S_DETAILS' => $lang['EasyBAN_BTN_details'],

			'L_FILTER' => $lang['EasyBAN_BTN_Filter'],
			'L_FILTER_BY' => $lang['EasyBAN_Filter_by'],
			'S_FILTER_OPTIONS' => $filter_select_options,
			'L_FILTER_STATUS' => $filter_status,

			'L_BACK_WITHSEL' => $lang['EasyBAN_BTN_wgroup'],
			'L_BAN' => $lang['EasyBAN_BTN_BAN'],
			'L_UNBAN' => $lang['EasyBAN_BTN_UNBAN'],
			'L_GO' => $lang['Go'],

			'S_HIDDEN_FIELDS' =>  '<input type="hidden" name="mode" value="admin" />'
								. '<input type="hidden" name="filter_option_row" value="' . htmlspecialchars($filter_option) . '" />',
			'S_ACTION' => append_sid('admin_EasyBAN.' . $phpEx))
		);

	}

	if( $mode == 'settings' )
	{
		//=================
		//
		//	configuration
		//
		//=================
		$template->set_filenames(array(
			"body" => "admin/EasyBAN_settings.tpl")
		);
	
		//	fills the settings array
		//
		if ( $submit != $lang['EasyBAN_BTN_update'])
		{
			if( $submit != $lang['EasyBAN_BTN_getdef'] )
			{
				$settings = get_settings(1);
			}
			else
			{
				$settings = get_settings(0);
			}
		}

		$version_info = check_ver(EASYBAN_VER, EASYBAN_VER_CHKFILE);

		$template->assign_vars(array(
			'VERSION_INFO'	=> $version_info)
		);
	
		//	prepares the output variables
		//
		$radio = array();
		foreach($default_cfg_values as $key => $val)
		{
			//	move data to the template variables
			//
			if( ($submit != '') && ($submit != $lang['EasyBAN_BTN_getdef']) )
			{
				//	if not called from the menu AND not getting the default values
				//
				$post_value = stripslashes(trim($HTTP_POST_VARS[$key]));
			}
			else
			{
				$post_value = $settings[$key];
			}

			if( $post_value == '' )
			{
				$post_value = $val;	//	 get the default values if empty
			}

			//	fills the settings array to properly set the <option> values and, if required, update the table
			//
			$settings[$key] = $post_value;

			//	handle radio buttons
			//
			if ( substr($key, -5) == 'radio' )
			{
				$radio[$key][$post_value] = 'checked="checked"';
				$template->assign_vars( array( $key . $post_value => 'checked="checked"' ) );
			}
			else if( $key == 'EasyBAN_private_last_report' )
			{
				$template->assign_vars( array( $key => create_date($board_config['default_dateformat'], $post_value, $board_config['board_timezone']) ) );
			}
			else
			{
				$template->assign_vars( array( $key => $post_value ) );
			}
		}

		$select_info =  '<option value="none"' . (($settings['EasyBAN_infoe'] == 'none') ? ' selected="selected"' : ''). '>' . $lang['EasyBAN_infoe_none'] . '</option>' . "\n";
		$select_info .= '<option value="each"' . (($settings['EasyBAN_infoe'] == 'each') ? ' selected="selected"' : ''). '>' . $lang['EasyBAN_infoe_each'] . '</option>' . "\n";
		$select_info .= '<option value="day"'  . (($settings['EasyBAN_infoe'] == 'day')  ? ' selected="selected"' : ''). '>' . $lang['EasyBAN_infoe_day']  . '</option>' . "\n";
		$select_info .= '<option value="week"' . (($settings['EasyBAN_infoe'] == 'week') ? ' selected="selected"' : ''). '>' . $lang['EasyBAN_infoe_week'] . '</option>' . "\n";

		$tmp = '';
		if ( $submit == $lang['EasyBAN_BTN_getdef'])
		{
			$tmp = $lang['EasyBAN_conf_default'];
		}

		if ( $submit == $lang['EasyBAN_BTN_update'])
		{
			$errors = update_settings($settings);
			if ( $errors > 0)
			{
				$tmp = $lang['EasyBAN_conf_not_updated'];
			}
			else
			{
				$tmp = $lang['EasyBAN_conf_updated'];
			}
		}
		if ( $tmp != '' )
		{
			$template->assign_vars(array(
					'L_UPDATE_CONF_MSG' => '<fieldset class="forumline" style="margin:10px;padding:8px;text-align:center;"><p class="gen"><b>' . $tmp . '</b></p></fieldset>' )
				);
		}

		$template->assign_vars(array(
			'S_ACTION' => append_sid('admin_EasyBAN.' . $phpEx),

			'U_HELP' => append_sid('admin_EasyBAN.' . $phpEx . '?mode=help'),
			'L_HELP' => $lang['EasyBAN_moreinfo'],

			'L_YES' => $lang['EasyBAN_y'],
			'L_NO' => $lang['EasyBAN_n'],
			'L_ULTD' => $lang['EasyBAN_ultd'],

			'L_SETTINGS' => $lang['EasyBAN_settings'],
			'L_DESC' => $lang['EasyBAN_settings_desc'],

			'L_INFOEB_TITLE' => $lang['EasyBAN_infoe'],
			'L_INFOEB_DESC' => $lang['EasyBAN_infoe_desc'],
			'L_INFOEB_FREQ' => $lang['EasyBAN_infoe_freq'],
			'SELECT_INFOEB' => $select_info,

			'L_QUAR_TITLE' => $lang['EasyBAN_quar'],
			'L_QUAR_DESC' => $lang['EasyBAN_quar_desc'],
			'L_QUAR_WORD' => $lang['EasyBAN_quar_word'],
			'L_QUAR_COMA' => $lang['EasyBAN_quar_comasep'],
			'L_QUAR_LINK' => $lang['EasyBAN_quar_links'],
			'L_QUAR_ACTIVE' => $lang['EasyBAN_quar_active'],

			'L_SINBAN_TITLE' => $lang['EasyBAN_sinban'],
			'L_SINBAN_DESC' => $lang['EasyBAN_sinban_desc'],
			'L_SINBAN_USER' => $lang['EasyBAN_sinban_all'],
			'L_SINBAN_ANONY' => $lang['EasyBAN_sinban_anony'],

			'L_GRPBAN_TITLE' => $lang['EasyBAN_grpban'],
			'L_GRPBAN_DESC' => $lang['EasyBAN_grpban_desc'],
			'L_GRPBAN_USER' => $lang['EasyBAN_grpban_user'],
			'L_GRPBAN_EMAIL' => $lang['EasyBAN_grpban_email'],
			'L_GRPBAN_IP' => $lang['EasyBAN_grpban_ip'],

			'L_PRIVATE_TITLE' => $lang['EasyBAN_private'],
			'L_PRIVATE_DESC' => $lang['EasyBAN_private_desc'],
			'L_PRIVATE_LASTREPORT' => $lang['EasyBAN_private_lastreport'],

			'L_SUBMIT' => $lang['EasyBAN_BTN_update'],
			'L_DEFAULT' => $lang['EasyBAN_BTN_getdef'],

			'MODE' => 'settings')
		);

	}
}
//	actually outputs the template we've built
//
$template->pparse('body');

//	EasyBAN own footer
//
$template->set_filenames(array(
	'EasyBAN_footer' => 'admin/EasyBAN_footer.tpl')
);

$template->assign_vars(array(
	'L_POWERED_BY' => $lang['EasyBAN_powered_by'])
);

$template->pparse('EasyBAN_footer');

//	output the forum footer
//
include('page_footer_admin.'.$phpEx);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	update the configuration table
function update_settings($settings)
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $db;

	$errors = 0;

	//	loop through all the settings and writes the EeasyBAN ones
	//
	foreach( $settings as $config_name => $config_value )
	{
		if( substr($config_name, 0, 16) != 'EasyBAN_private_' )
		{
			$config_value = str_replace("'", "''", $config_value);
	
			$sql = 'SELECT * FROM ' . CONFIG_TABLE . "
					WHERE
					config_name = '$config_name' ";
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, $lang['EasyBAN_err_config_info'], '', __LINE__, __FILE__, $sql);
				//$errors++;
			}
			else
			{
				if( $db->sql_affectedrows() == 0 )
				{
					$sql = 'INSERT INTO ' . CONFIG_TABLE . " ( config_name, config_value )
							VALUES ( '$config_name', '$config_value' )" ;
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, $lang['EasyBAN_err_config_info'], '', __LINE__, __FILE__, $sql);
						//$errors++;
					}
				}
				else
				{
					$sql = 'UPDATE ' . CONFIG_TABLE . " SET config_value = '$config_value'
						WHERE
						config_name = '$config_name' " ;
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, $lang['EasyBAN_err_config_info'], '', __LINE__, __FILE__, $sql);
						//$errors++;
					}
				}
			}
		}
	}
	
	return $errors;
}
/*
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	//	format the text of the message
	//	(to be implemented in the next version)
	function format_message($message, $bbcode_uid, $enable_html)
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	{
		global $board_config;
		//	include_once($phpbb_root_path . 'includes/bbcode.' . $phpEx); // next version
	
		if( !$board_config['allow_html'] && $enable_html )
		{
			$message = preg_replace('#(<)([\/]?.*?)(>)#is','&lt;\2&gt;', $message);
		}
		if($bbcode_uid != '')
		{
			$message = ($board_config['allow_bbcode']) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $message);
		}
		return $message;
	}
*/
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	handling post HIDE/UNHIDE
//
function _hide($r_hide, $c_alltopic, $topic_id, $post_id, $poster_id, $poster_email, $poster_ip, $update_info)
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $db, $lang, $settings;

	$u = count($update_info);

//	echo '_hide => r_hide:'.$r_hide.', c_alltopic:'.$c_alltopic.', topic_id:'.$topic_id.', post_id:'.$post_id.', poster_id:'.$poster_id.', poster_email:'.$poster_email.', poster_ip:'.$poster_ip.'<br>';

	if( ($c_alltopic == 1) )
	{
		//=========
		//	TOPIC
		//=========
		$sql = 'SELECT * FROM ' . HIDED_TABLE . " 
				WHERE
				hide_id = $topic_id AND
				hide_type = 1 ";
		if( $result = $db->sql_query($sql) )
		{
			$row_post = $db->sql_fetchrow($result);

			if( $row_post['hide_id'] == $topic_id )
			{
				//	unhide topic
				//
				$sql = 'DELETE FROM ' . HIDED_TABLE . " 
						WHERE 
						hide_id = $topic_id AND 
						hide_type = 1 ";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, $lang['EasyBAN_err_nodel_hide'], '', __LINE__, __FILE__, $sql);
				}
				$update_info[$u] = $lang['EasyBAN_Topic'] . $lang['EasyBAN_UnHidden'] . ' (' . $topic_id . ')';
			}
			if( intval($row_post['hide_id']) == 0 )
			{
				//	hide topic
				//
				$sql = "INSERT INTO " . HIDED_TABLE . " ( hide_id, hide_type )
						VALUES ( $topic_id, 1 ) ";
				if( !$db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, $lang['EasyBAN_err_noins_hide'], '', __LINE__, __FILE__, $sql);
				}
				$update_info[$u] = $lang['EasyBAN_Topic'] . $lang['EasyBAN_Hidden'] . ' (' . $topic_id . ')';
			}
		}
		else
		{
			message_die(GENERAL_ERROR, $lang['EasyBAN_err_nocheck_hide'], '', __LINE__, __FILE__, $sql);
		}

		//
		//	In this case posts are not updated as it will not be possible to view them anyways.
		//	We can return to the caller
		//
		return $update_info;
		//
	}

	//===========
	//	POST(s)
	//===========
	if( ($poster_id <= 0) && ($settings['EasyBAN_sinban_all_radio'] == 1) && ($settings['EasyBAN_sinban_anony_radio'] == 0) 
		|| ($poster_id > 0) && ($settings['EasyBAN_sinban_all_radio'] == 1) )
	{
		//	hide ALL posts made by this user if he is NOT ANONYMOUS
		//
		$sql = 'SELECT  p.*, 
						i.* 
				FROM ' 
					. POSTS_TABLE . ' p, '
					. POSTS_TEXT_TABLE . " i 
				WHERE 
				p.poster_id = $poster_id AND 
				i.post_id = p.post_id ";
	}
	else
	{
		//	hide ONLY this post
		//
		$sql = 'SELECT  p.*, 
						i.* 
				FROM ' 
					. POSTS_TABLE . ' p, '
					. POSTS_TEXT_TABLE . " i 
				WHERE 
				p.post_id = $post_id AND 
				i.post_id = p.post_id ";
	}

	if( !$user_result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_post_hiding'], '', __LINE__, __FILE__, $sql);
	}

	while( $user_post = $db->sql_fetchrow($user_result) )
	{
		$post_id2ban = $user_post['post_id'];

		$sql = 'SELECT * FROM ' . HIDED_TABLE . " 
				WHERE 
				hide_id = $post_id2ban AND 
				hide_type = 0 ";
		if( $result = $db->sql_query($sql) )
		{
			$row_post = $db->sql_fetchrow($result);

			switch( $r_hide )
			{
				case 1:
					//
					//	hide post
					//
					if( $row_post['hide_quar'] == 1 )
					{
						//	post was quarantined, remove from quarantine
						//
						$sql = "UPDATE " . HIDED_TABLE . " SET hide_quar = 0
								WHERE 
								hide_id = $post_id2ban AND 
								hide_type = 0 ";
						if( !$db->sql_query($sql) )
						{
							message_die(GENERAL_ERROR, $lang['EasyBAN_err_noupd_hide'], '', __LINE__, __FILE__, $sql);
						}
						$update_info[$u] = $lang['EasyBAN_Post'] . $lang['EasyBAN_DHidden'] . ' (' . $post_id2ban . ')';
					}
					if( intval($row_post['hide_id']) == 0 )
					{
						//	post was not quarantined nor hidden
						//
						$sql = "INSERT INTO " . HIDED_TABLE . " ( hide_id ) 
								VALUES ( $post_id2ban ) ";
						if( !$db->sql_query($sql) )
						{
							message_die(GENERAL_ERROR, $lang['EasyBAN_err_noins_hide'], '', __LINE__, __FILE__, $sql);
						}
						$update_info[$u] = $lang['EasyBAN_Post'] . $lang['EasyBAN_Hidden'] . ' (' . $post_id2ban . ')';
					}
					break;

				case 0:
					if( $row_post['hide_id'] > 0 )
					{
						//	unhide post
						//
						$sql = 'DELETE FROM ' . HIDED_TABLE . " 
								WHERE 
								hide_id = $post_id2ban AND 
								hide_type = 0 ";
						if( !$db->sql_query($sql) )
						{
							message_die(GENERAL_ERROR, $lang['EasyBAN_err_nodel_hide'], '', __LINE__, __FILE__, $sql);
						}
						$update_info[$u] = $lang['EasyBAN_Post'] . $lang['EasyBAN_UnHidden'] . ' (' . $post_id2ban . ')';
					}
					break;
			}
			$u++;
		}
		else
		{
			message_die(GENERAL_ERROR, $lang['EasyBAN_err_nocheck_hide'], '', __LINE__, __FILE__, $sql);
		}
	}

	return $update_info;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	handling user,email and ip BAN/UNBAN
//
function _ban($c_ban_user, $c_ban_email, $c_ban_ip, $post_id, $poster_id, $poster_email, $poster_ip, $update_info)
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $db, $lang;

	$u = count($update_info);

//	echo '_ban => c_ban_user:'.$c_ban_user.', c_ban_email:'.$c_ban_email.', c_ban_ip:'.$c_ban_ip.'<br>'.
//	'post_id:'.$post_id.', poster_id:'.$poster_id.', poster_email:'.$poster_email.', poster_ip:'.$poster_ip.'<br>';

	//========
	//	USER
	//========
	switch( $c_ban_user )
	{
		case 1:
			//
			//	ban
			//
			$sql = 'SELECT * FROM ' . BANLIST_TABLE . " 
					WHERE ban_userid = $poster_id ";
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, $lang['EasyBAN_err_bantable'], '', __LINE__, __FILE__, $sql);
			}
			if ( !$row = $db->sql_fetchrow($result) )
			{
				$sql = "INSERT INTO " . BANLIST_TABLE . " ( ban_userid )
						VALUES ( '$poster_id' )" ;
				if( !$result = $db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, $lang['EasyBAN_err_banins'], '', __LINE__, __FILE__, $sql);
				}
				$update_info[$u] = $lang['EasyBAN_UsrBan'] . ' (' . $poster_id . ')';
			}
			else
			{
				$update_info[$u] = $lang['EasyBAN_UsrABan'] . ' (' . $poster_id . ')';
			}
			$u++;
			break;

		case 0:
			//
			//	unban
			//
			$sql = 'DELETE FROM ' . BANLIST_TABLE . " 
					WHERE ban_userid = $poster_id ";
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, $lang['EasyBAN_err_bandel'], '', __LINE__, __FILE__, $sql);
			}
			if( $db->sql_affectedrows() > 0 )
			{
				$update_info[$u] = $lang['EasyBAN_UsrDBan'] . ' (' . $poster_id . ')';
				$u++;
			}
			break;

	}

	//=========
	//	EMAIL
	//=========
	if( $poster_email != '' )
	{
		switch( $c_ban_email )
		{
			case 1:
				//
				//	ban
				//
				$sql = 'SELECT * FROM ' . BANLIST_TABLE . " 
						WHERE ban_email = '" . $poster_email . "' ";
				if( !$result = $db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, $lang['EasyBAN_err_bantable'], '', __LINE__, __FILE__, $sql);
				}
				if ( !$row = $db->sql_fetchrow($result) )
				{
					$sql = "INSERT INTO " . BANLIST_TABLE . " ( ban_email )
							VALUES ( '$poster_email' )" ;
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, $lang['EasyBAN_err_banins'], '', __LINE__, __FILE__, $sql);
					}
					$update_info[$u] = $lang['EasyBAN_EmaBan'] . ' (' . $poster_email . ')';
				}
				else
				{
					$update_info[$u] = $lang['EasyBAN_EmaABan'] . ' (' . $poster_email . ')';
				}
				$u++;
				break;
	
			case 0:
				//
				//	unban
				//
				$sql = 'DELETE FROM ' . BANLIST_TABLE . " 
						WHERE ban_email = '" . $poster_email . "' ";
				if( !$result = $db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, $lang['EasyBAN_err_bandel'], '', __LINE__, __FILE__, $sql);
				}
				if( $db->sql_affectedrows() > 0 )
				{
					$update_info[$u] = $lang['EasyBAN_EmaDBan'] . ' (' . $poster_email . ')';
					$u++;
				}
				break;
		}
	}

	//======
	//	IP
	//======
	if( $poster_ip != '' )
	{
		switch( $c_ban_ip )
		{
			case 1:
				//
				//	ban
				//
				$sql = 'SELECT * FROM ' . BANLIST_TABLE . " 
						WHERE ban_ip = '$poster_ip' ";
				if( !$result = $db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, $lang['EasyBAN_err_bantable'], '', __LINE__, __FILE__, $sql);
				}
				if ( !$row = $db->sql_fetchrow($result) )
				{
					$sql = "INSERT INTO " . BANLIST_TABLE . " ( ban_ip )
							VALUES ( '$poster_ip' )" ;
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, $lang['EasyBAN_err_banins'], '', __LINE__, __FILE__, $sql);
					}
					$update_info[$u] = $lang['EasyBAN_IPBan'] . ' (' . decode_ip($poster_ip) . ')';
				}
				else
				{
					$update_info[$u] = $lang['EasyBAN_IPABan'] . ' (' . decode_ip($poster_ip) . ')';
				}
				$u++;
				break;

			case 0:
				//
				//	unban
				//
				$sql = 'DELETE FROM ' . BANLIST_TABLE . " 
						WHERE ban_ip = '$poster_ip' ";
				if( !$result = $db->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, $lang['EasyBAN_err_bandel'], '', __LINE__, __FILE__, $sql);
				}
				if( $db->sql_affectedrows() > 0 )
				{
					$update_info[$u] = $lang['EasyBAN_IPDBan'] . ' (' . $poster_ip . ')';
					$u++;
				}
				break;
		}
	}

	return $update_info;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	check for new version
function check_ver($version, $check_file)
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $lang;

	$current_version = explode('.', $version);
	$head_revision = (int) $current_version[0];
	$major_revision = (int) $current_version[1];
	$minor_revision = (int) $current_version[2];

	$errno = 0;
	$errstr = $version_info = '';

	if ($fsock = @fsockopen('grandolini.org', 80, $errno, $errstr, 10))
	{
		@fputs($fsock, "GET /updatecheck/$check_file.txt HTTP/1.1\r\n");
		@fputs($fsock, "HOST: grandolini.net\r\n");
		@fputs($fsock, "Connection: close\r\n\r\n");

		$get_info = false;
		while (!@feof($fsock))
		{
			if ($get_info)
			{
				$version_info .= @fread($fsock, 1024);
			}
			else
			{
				if (@fgets($fsock, 1024) == "\r\n")
				{
					$get_info = true;
				}
			}
		}
		@fclose($fsock);

		$version_info = explode("\n", $version_info);
		$latest_head_revision = (int) $version_info[0];
		$latest_major_revision = (int) $version_info[1];
		$latest_minor_revision = (int) $version_info[2];
		$latest_version = (int) $version_info[0] . '.' . (int) $version_info[1] . '.' . (int) $version_info[2];

		if ($head_revision == $latest_head_revision && $major_revision == $latest_major_revision && $minor_revision == $latest_minor_revision)
		{
			$version_info = '<fieldset style="margin:10px;padding:8px;text-align:center;border:1px solid green;color:green;background:#A7DF6F;">';
			$version_info .= '<p style="color:green;font-weight:bold;">' . $lang['Version_up_to_date'] . '</p>';
		}
		else
		{
			$version_info = '<fieldset style="margin:10px;padding:8px;text-align:center;border:1px solid red;color:red;background:#FF8F8F;">';
			$version_info .= '<p style="color:red;font-weight:bold;">' . $lang['Version_not_up_to_date'];
			$version_info .= '<br />' . sprintf($lang['Latest_version_info'], $latest_version) . ' ' . sprintf($lang['Current_version_info'], $version) . '</p>';
		}
	}
	else
	{
		if ($errstr)
		{
			$version_info = '<p style="color:red">' . sprintf($lang['Connect_socket_error'], $errstr) . '</p>';
		}
		else
		{
			$version_info = '<p>' . $lang['Socket_functions_disabled'] . '</p>';
		}
	}

	$version_info .= '<p>' . $lang['Mailing_list_subscribe_reminder'] . '</p></fieldset>';

	return $version_info;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	get post data
function get_post_data($post_id)
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $db;

	$sql = 'SELECT 	p.post_id, p.post_username, p.post_time, p.topic_id, p.forum_id, p.poster_id, p.poster_ip, p.enable_html, 
					i.post_subject, i.post_text,  i.bbcode_uid, 
					u.username, u.user_email, 
					f.forum_name, 
					t.topic_title, t.topic_id 
			FROM ' 
				. POSTS_TABLE . ' p, '
				. POSTS_TEXT_TABLE . ' i, '
				. USERS_TABLE . ' u, '
				. FORUMS_TABLE . ' f, '
				. TOPICS_TABLE . " t 
			WHERE 
			p.post_id = $post_id AND 
			i.post_id = $post_id AND 
			u.user_id = p.poster_id AND 
			f.forum_id = p.forum_id AND 
			t.topic_id = p.topic_id ";

	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_post'] . $post_id, '', __LINE__, __FILE__, $sql);
	}
	$row = $db->sql_fetchrow($result);

	return $row;
}
?>